% bornes.m
% bornes inferieures au rang generique
% permettent de trouver les exceptions pour les ordres 3 ou 4
% P.Comon, 29 juin 2006, revise 8 aout 2008
% Ce code a servi a generer les tableaux dans les references suivantes:
% REFERENCES: 
% [1] P. Comon and J. ten Berge, Icassp'08, Las Vegas, 
%     March 30 - April 4, 2008, pp.3313--3316. 
%     DOI: 10.1109/ICASSP.2008.4518359
% [2] P. Comon, J. M. F. ten Berge et al, 
%     Linear Algebra Appl., 430(11--12):2997-3007, June 2009. 
%     DOI: 10.1016/j.laa.2009.01.014
format compact
% CAS DIMENSIONS EGALES
fprintf('====================\n');
fprintf('Cas non symetrique de dimensions egales\n')
R=[];
for d=3:4,
    for k=2:9,
    R(d-2,k-1)=ceil(k^d/(k*d-d+1));
    end;
end;
R

fprintf('idem mais sans arondi pour detecter les ratios entiers\n')
Re=[];
for d=3:4,
    for k=2:9,
    Re(d-2,k-1)=k^d/(k*d-d+1);
    end;
end;
Re

% CAS NON SYMETRIQUE
fprintf('====================\n');
fprintf('Cas non symetrique\n')
R=[];
for n3=2:4,
    for n1=2:12,
    for n2=2:5,
    R(n1-1,n2-1)=ceil(n1*n2*n3/(n1+n2+n3-2));
end;end;
n3,R
end;
    
fprintf('idem mais sans arondi pour detecter les ratios entiers\n')
Re=[];
for n3=2:4,
    for n1=2:12,
    for n2=2:5,
    Re(n1-1,n2-1)=n1*n2*n3/(n1+n2+n3-2);
end;end;
n3,Re
end;

% CAS INDSCAL
fprintf('====================\n');
fprintf('Cas INDSCAL\n')
R=[];
for n1=2:10,
    for n2=2:5
        R(n1-1,n2-1)=ceil(n2*(n2+1)/2*n1/(n1+n2-1));
    end;
end;
R

fprintf('idem mais sans arondi pour detecter les ratios entiers\n')
Re=[];
for n1=2:10,
    for n2=2:5
        Re(n1-1,n2-1)=n2*(n2+1)/2*n1/(n1+n2-1);
    end;
end;
Re